<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>PMD Update </title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="{{ static_url("main.css") }}" type="text/css">
    <script>
        function textAreaAdjust(o) {
            o.style.height = "1px";
            o.style.height = (25 + o.scrollHeight) + "px";
        }
    </script>
</head>

<body>
<header>
    PMD Update
</header>
<div class="container">
    <div class="row">
        <div class="col-md-6 padding15">
            <button class="export_pmd btn btn-success">Export PMD</button>
            <a href="#" class="download_pmd_file btn btn-link disp-none">Download</a>

        </div>
        <div class="col-md-5 padding15">
            <button class="check_code btn btn-primary">Code Check</button>
            <button style="float: right" class="pmd-check btn btn-primary">pmd Check</button>
        </div>
    </div>
    <div class="row">
        <div class="col-md-6">
        <textarea rows="10" class="form-control pmd-string" placeholder="code1 = 100.2
code2 = 170.01" onkeyup="textAreaAdjust(this)" name="pmd_data"></textarea>
            <input type="button" class="form-control btn btn-success update-pmd" style="margin-top: 15px" value="Send">

            <div class="row p-demo disp-none" style="margin: 20px 0; border: 1px solid lightgray; border-radius: 3px">
                <div class="col-md-4">
                    <img class="p-demo-img" style="width: 80%" src="{{ static_url('images/excel.svg') }}">
                </div>
                <div class="col-md-8">
                    <p class="description">
                        ...
                    </p>
                </div>
            </div>
            <div class="row replace-box" style="margin-top: 20px">
                <div class="col-md-12">
                    <textarea disabled rows="2" class="form-control replace-code" onkeyup="textAreaAdjust(this)"
                              name="replace-code"></textarea>
                </div>
            </div>
        </div>
        <div class="col-md-6">
            <div class="row analyze">

            </div>
            <div class="row">
                <i class='cmplet disp-none' style='color: green'>Complete!</i>
            </div>

        </div>
    </div>
</div>
<div class="loader disp-none">
    <img style="width: 120px;position: fixed; top: 40%;left: 49%;" src="{{ static_url('images/loader1.gif') }}">
</div>
<script type="text/javascript" src="{{ static_url("validation.js") }}"></script>
<script type="text/javascript" src="{{ static_url("autonumeric.min.js") }}"></script>

<script>


    var form_state;

    function data_update(i, len) {
        $('.loader').removeClass('disp-none');
        var js = form_state[i];
        len -= 1;
        $.ajax(
            {
                type: "put",
                url: "/get-data",
                data: {js: JSON.stringify(js), act: "update_data"},
                success: function (data) {
                    if (data['status']) {
                        var index = i + 1;
                        var new_js = data['value'];
                        console.log(new_js);
                        if (!new_js['status']) {
                            console.log("No");
                            $("input[name=order-number-" + index + "]").addClass("is-invalid");
                        }
                        else {
                            $('.description').text(new_js['description']);
                            $('.p-demo-img').attr("src", new_js['image_url']);
                            $('.p-demo').removeClass("disp-none");
                            form_state[i] = new_js;
                            $("input[name=order-number-" + index + "]").removeClass("is-invalid").addClass("is-valid");
                            if (new_js['replace'].length > 0) {
                                $(".check-replace-" + index).text(new_js['replace'][0]['code']);
                                $(".replace-" + index).slideDown();
                            }
                            else
                                $(".replace-" + index).html("<i class='cmplet' style='color: green'>Complet!</i>").slideDown();
                        }
                    }
                    else {
                        alert("Error");
                    }
                    i = i + 1;
                    if (len > 0) {
                        data_update(i, len);
                    }
                    else {
                        $('.loader').addClass('disp-none');
                        {#$(".submit").prop("disabled", false);#}
                    }
                },
                error: function (status) {
                    var index = i + 1;
                    $("input[name=order-number-" + index + "]").addClass("is-invalid");
                    i = i + 1;
                    if (len > 0) {
                        data_update(i, len);
                    }
                    else $(".submit").prop("disabled", false);
                }
            });
        $('[data-toggle="tooltip"]').tooltip();
    }


    function textAreaAdjust(o) {
        o.style.height = "1px";
        o.style.height = (25 + o.scrollHeight) + "px";
    }

    $("textarea.pmd-string").on("change keyup", function () {
        var pmd_value = $(this).val().split("\n");
        var inp = "";
        var j = 0;
        form_state = [];
        $.each(pmd_value, function (i, item) {
            if (item.trim() !== "") {
                var row = item.split("=");
                if ($.trim(row[0]) && $.trim(row[1])) {
                    form_state[j] = {
                        'code': $.trim(row[0]), 'pmd': $.trim(row[1]), 'replace': [],
                        'rawcode': '',
                        'description': '',
                        'standard_ptn': '',
                        'weight': 0,
                        'coo': '',
                        'Lifecycle': '',
                        'Notes': '',
                        'datasheet': '',
                        'image_url': 'https://pnap.ir/wp-content/uploads/public/no_image_pnap600.jpg',
                        'replace_code': '',
                        'status': 0
                    };
                    j += 1;
                    inp += "<div class='col-md-6'><input disabled class='form-control order-number' rel='popover' name='order-number-" + j + "' data-id=" + j + " value=" + row[0] + "><div class='replace-" + j + "' style='font-size: 10px;'><a href='#' class='replace-link check-replace-" + j + "'></a></div></div><div class='col-md-4'> <input disabled class='form-control' name='pmd-value' data-id=" + j + " value=" + row[1] + "></div><div class='col-md-2'><span class='pmd-" + j + "'></span></div>";
                }
            }

        });
        console.log(form_state);
        $('.analyze').html(inp);

    });
    $(".check_code").click(function () {
        console.log(form_state);
        alert(form_state.length);
        if (form_state.length > 0)
            data_update(0, form_state.length)
    });

    $('.pmd-check').click(function () {
        $("input.order-number").each(function (i, item) {
            $.ajax(
                {
                    type: "POST",
                    url: "/product/check",
                    data: {code: $(this).val(), act: "exist"},
                    success: function (data) {
                        console.log(data);
                        if (data['status']) {
                            {#data_update(i, 1);#}
                            $("input[name=order-number-" + (i + 1) + "]").removeClass("is-invalid").addClass("is-valid");
                            $(".pmd-" + (i + 1)).html(parseFloat(data['value']['pmd'])).addClass("edited");
                            $(".dt-pmd-ratio-" + (i + 1)).html(parseFloat(data['value']['dt_pmd_ratio']));
                        }
                        else {
                            $("input[name=order-number-" + (i + 1) + "]").addClass("is-invalid").removeClass("is-valid");
                            $(".pmd-" + (i + 1)).html("-");
                            $("input[name=pmd-" + (i + 1) + "]").addClass("edited");
                        }
                    }
                });
        });
    });

    $(document).on("click", ".replace-link", function () {
        var textarea_ = $('textarea.replace-code');
        textarea_.val(textarea_.val() + $(this).text() + "\n");
        this.remove();
    });

    $('input.update-pmd').click(function (e) {
        e.preventDefault();
        {#console.log(form_state);#}
        $.ajax(
            {
                type: "POST",
                url: "/pmd/update",
                data: {pmddata: JSON.stringify(form_state), act: "pmd-ls-update"},
                success: function (data) {
                    console.log(data);
                    if (data['status']) {
                        alert(data['msg']);
                        {#data_update(i, 1);#}
                        {#$("input[name=order-number-" + (i + 1) + "]").removeClass("is-invalid").addClass("is-valid");#}
                        {#$(".pmd-" + (i + 1)).html(parseFloat(data['value']['pmd'])).addClass("edited");#}
                        {#$(".dt-pmd-ratio-" + (i + 1)).html(parseFloat(data['value']['dt_pmd_ratio']));#}
                    }
                    else {
                        alert("Error");
                        {#$("input[name=order-number-" + (i + 1) + "]").addClass("is-invalid").removeClass("is-valid");#}
                        {#$(".pmd-" + (i + 1)).html("-");#}
                        {#$("input[name=pmd-" + (i + 1) + "]").addClass("edited");#}
                    }
                }
            });
    });
    $('button.export_pmd').click(function (e) {
        e.preventDefault();
        var ls = $("textarea.pmd-string").val().split("\n");
        console.log(ls);
        var j = 0;
        form_state = [];
        $.each(ls, function (i, item) {
            if (item.trim() !== "") {
                var row = item.split("=");
                if ($.trim(row[0])) {
                    form_state[j] = $.trim(row[0]);
                    j += 1;
                }
            }
        });
        $.ajax(
            {
                type: "POST",
                url: "/pmd/export",
                data: {pmddata: JSON.stringify(form_state), act: "export_pmd"},
                success: function (data) {
                    console.log(data);
                    if (data['status']) {
                        console.log(data['value']);
                        $("a.download_pmd_file").attr("href", "/" + data['value']).removeClass('disp-none');
                    }
                    else {
                        alert(data['msg'])
                    }
                }
            });
    });
</script>
</body>
</html>